-------------------------------------------------------------------------------
-- system_stub.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

entity system_stub is
  port (
    fpga_0_clk_board_config_sys_clk_pin : in std_logic;
    fpga_0_USER_IO_GPIO2_d_out_pin : out std_logic_vector(0 to 7);
    fpga_0_USER_IO_GPIO_in_pin : in std_logic_vector(0 to 7);
    fpga_0_rs232_db9_RX_pin : in std_logic;
    fpga_0_rs232_db9_TX_pin : out std_logic;
    fpga_0_rs232_usb_RX_pin : in std_logic;
    fpga_0_rs232_usb_TX_pin : out std_logic;
    fpga_0_clk_board_config_cfg_radio_dat_out_pin : out std_logic;
    fpga_0_clk_board_config_cfg_radio_csb_out_pin : out std_logic;
    fpga_0_clk_board_config_cfg_radio_en_out_pin : out std_logic;
    fpga_0_clk_board_config_cfg_radio_clk_out_pin : out std_logic;
    fpga_0_clk_board_config_cfg_logic_dat_out_pin : out std_logic;
    fpga_0_clk_board_config_cfg_logic_csb_out_pin : out std_logic;
    fpga_0_clk_board_config_cfg_logic_en_out_pin : out std_logic;
    fpga_0_clk_board_config_cfg_logic_clk_out_pin : out std_logic;
    xps_ll_temac_0_RXN_0_pin : in std_logic;
    xps_ll_temac_0_RXP_0_pin : in std_logic;
    xps_ll_temac_0_TXN_0_pin : out std_logic;
    xps_ll_temac_0_TXP_0_pin : out std_logic;
    xps_ll_temac_0_RXN_1_pin : in std_logic;
    xps_ll_temac_0_RXP_1_pin : in std_logic;
    xps_ll_temac_0_TXN_1_pin : out std_logic;
    xps_ll_temac_0_TXP_1_pin : out std_logic;
    xps_ll_temac_0_MGTCLK_N_pin : in std_logic;
    xps_ll_temac_0_MGTCLK_P_pin : in std_logic;
    sys_clk_pin : in std_logic;
    sys_rst_pin : in std_logic
  );
end system_stub;

architecture STRUCTURE of system_stub is

  component system is
    port (
      fpga_0_clk_board_config_sys_clk_pin : in std_logic;
      fpga_0_USER_IO_GPIO2_d_out_pin : out std_logic_vector(0 to 7);
      fpga_0_USER_IO_GPIO_in_pin : in std_logic_vector(0 to 7);
      fpga_0_rs232_db9_RX_pin : in std_logic;
      fpga_0_rs232_db9_TX_pin : out std_logic;
      fpga_0_rs232_usb_RX_pin : in std_logic;
      fpga_0_rs232_usb_TX_pin : out std_logic;
      fpga_0_clk_board_config_cfg_radio_dat_out_pin : out std_logic;
      fpga_0_clk_board_config_cfg_radio_csb_out_pin : out std_logic;
      fpga_0_clk_board_config_cfg_radio_en_out_pin : out std_logic;
      fpga_0_clk_board_config_cfg_radio_clk_out_pin : out std_logic;
      fpga_0_clk_board_config_cfg_logic_dat_out_pin : out std_logic;
      fpga_0_clk_board_config_cfg_logic_csb_out_pin : out std_logic;
      fpga_0_clk_board_config_cfg_logic_en_out_pin : out std_logic;
      fpga_0_clk_board_config_cfg_logic_clk_out_pin : out std_logic;
      xps_ll_temac_0_RXN_0_pin : in std_logic;
      xps_ll_temac_0_RXP_0_pin : in std_logic;
      xps_ll_temac_0_TXN_0_pin : out std_logic;
      xps_ll_temac_0_TXP_0_pin : out std_logic;
      xps_ll_temac_0_RXN_1_pin : in std_logic;
      xps_ll_temac_0_RXP_1_pin : in std_logic;
      xps_ll_temac_0_TXN_1_pin : out std_logic;
      xps_ll_temac_0_TXP_1_pin : out std_logic;
      xps_ll_temac_0_MGTCLK_N_pin : in std_logic;
      xps_ll_temac_0_MGTCLK_P_pin : in std_logic;
      sys_clk_pin : in std_logic;
      sys_rst_pin : in std_logic
    );
  end component;

begin

  system_i : system
    port map (
      fpga_0_clk_board_config_sys_clk_pin => fpga_0_clk_board_config_sys_clk_pin,
      fpga_0_USER_IO_GPIO2_d_out_pin => fpga_0_USER_IO_GPIO2_d_out_pin,
      fpga_0_USER_IO_GPIO_in_pin => fpga_0_USER_IO_GPIO_in_pin,
      fpga_0_rs232_db9_RX_pin => fpga_0_rs232_db9_RX_pin,
      fpga_0_rs232_db9_TX_pin => fpga_0_rs232_db9_TX_pin,
      fpga_0_rs232_usb_RX_pin => fpga_0_rs232_usb_RX_pin,
      fpga_0_rs232_usb_TX_pin => fpga_0_rs232_usb_TX_pin,
      fpga_0_clk_board_config_cfg_radio_dat_out_pin => fpga_0_clk_board_config_cfg_radio_dat_out_pin,
      fpga_0_clk_board_config_cfg_radio_csb_out_pin => fpga_0_clk_board_config_cfg_radio_csb_out_pin,
      fpga_0_clk_board_config_cfg_radio_en_out_pin => fpga_0_clk_board_config_cfg_radio_en_out_pin,
      fpga_0_clk_board_config_cfg_radio_clk_out_pin => fpga_0_clk_board_config_cfg_radio_clk_out_pin,
      fpga_0_clk_board_config_cfg_logic_dat_out_pin => fpga_0_clk_board_config_cfg_logic_dat_out_pin,
      fpga_0_clk_board_config_cfg_logic_csb_out_pin => fpga_0_clk_board_config_cfg_logic_csb_out_pin,
      fpga_0_clk_board_config_cfg_logic_en_out_pin => fpga_0_clk_board_config_cfg_logic_en_out_pin,
      fpga_0_clk_board_config_cfg_logic_clk_out_pin => fpga_0_clk_board_config_cfg_logic_clk_out_pin,
      xps_ll_temac_0_RXN_0_pin => xps_ll_temac_0_RXN_0_pin,
      xps_ll_temac_0_RXP_0_pin => xps_ll_temac_0_RXP_0_pin,
      xps_ll_temac_0_TXN_0_pin => xps_ll_temac_0_TXN_0_pin,
      xps_ll_temac_0_TXP_0_pin => xps_ll_temac_0_TXP_0_pin,
      xps_ll_temac_0_RXN_1_pin => xps_ll_temac_0_RXN_1_pin,
      xps_ll_temac_0_RXP_1_pin => xps_ll_temac_0_RXP_1_pin,
      xps_ll_temac_0_TXN_1_pin => xps_ll_temac_0_TXN_1_pin,
      xps_ll_temac_0_TXP_1_pin => xps_ll_temac_0_TXP_1_pin,
      xps_ll_temac_0_MGTCLK_N_pin => xps_ll_temac_0_MGTCLK_N_pin,
      xps_ll_temac_0_MGTCLK_P_pin => xps_ll_temac_0_MGTCLK_P_pin,
      sys_clk_pin => sys_clk_pin,
      sys_rst_pin => sys_rst_pin
    );

end architecture STRUCTURE;

